#include <allegro.h>

#include "space.h"
#include "collide.h"
#include "badguy.h"


/*
   Creates a badguy
*/
void MakeBadGuy(PLAYER *bad, int type, int xLoc, int yLoc)
{
  bad->x = xLoc;
  bad->y = yLoc;
  bad->frame = 0;
  bad->drivePower = 0;
  bad->disTravel = 0;
  bad->action = type;  /* type of badguy */

  switch(type)
  {
    case 0:  /* sphere fighter */
             bad->speed = 3;
             bad->weaponPower = bad->maxWeaponPower = 100;
             bad->health = 0;
             bad->score = 100;
             bad->curLaser = 0;
             bad->numMissles = 0;
             bad->weapons = 1;
             break;
    case 1:  /* sphere fighter #2 */
             bad->speed = 3;
             bad->weaponPower = bad->maxWeaponPower = 110;
             bad->health = 1;
             bad->score = 150;
             bad->curLaser = 0;
             bad->numMissles = 0;
             bad->weapons = 1;
             break;
    case 2:  /* Boss #1 */
             bad->speed = 2;
             bad->weaponPower = bad->maxWeaponPower = 450;
             bad->health = 30;
             bad->score = 1800;
             bad->curLaser = 0;
             bad->weapons = 1;
             break;
    case 4:  /* Boss #2 */
             bad->speed = 2;
             bad->weaponPower = bad->maxWeaponPower = 500;
             bad->health = 30;
             bad->score = 2000;
             bad->curLaser = 0;
             bad->weapons = 1 + 16;
             break;
    default: /* if bad type just make a sphere fighter */
             bad->speed = 3;
             bad->weaponPower = bad->maxWeaponPower = 100;
             bad->health = 0;
             bad->score = 100;
             bad->curLaser = 0;
             bad->numMissles = 0;
             bad->weapons = 1;
             bad->action = 0;
             break;

  }
}

/*
   Does the enemy thinking.
*/
void EnemyThink(int bad)
{
  switch(badGuys[bad].action)
  {
    case 0:  /* sphere fighter #1 */
             SphereFighter1Think(bad);
             break;
    case 1:  /* sphere fighter #2 */
             SphereFighter2Think(bad);
             break;
    case 2:  /* Boss #1 */

             break;
    case 3:  /* Boss #2 */

             break;
  }
}

/*
   Specific enemy thinking routines.
*/

/* Sphere fighter #1 */
void SphereFighter1Think(int bad)
{
  register int i = 0;

  badGuys[bad].other[0]--;

  /* restore some weapon power */
  badGuys[bad].weaponPower += 1;

  /* adjust position */
  if((random() % 2) == 1)
  {
    badGuys[bad].x += badGuys[bad].speed;
  }

  /* Try to get infront of player */
  if((badGuys[bad].y+8) < me.y) /* above player */
  {
    if((random() % 2) == 1)
    {
      badGuys[bad].y += badGuys[bad].speed;
    }
  } else if((badGuys[bad].y+11) > (me.y+ship[me.action].y))/* below player */
  {
    if((random() % 2) == 1)
    {
      badGuys[bad].y -= badGuys[bad].speed;
    }
  } else /* infront of player */
  {
    if(badGuys[bad].other[0] <= 0 && me.health >= 0)
    {
      /* Lets fire a shots */
      if(badGuys[bad].weaponPower >= 10)
      {
        badGuys[bad].weaponPower -= 10;
        i = 0;
        do {
          if(enemyShots[i].type == -1)
          {
            enemyShots[i].type = badGuys[bad].curLaser;
            enemyShots[i].x = badGuys[bad].x + enemies[1].x - 10;
            enemyShots[i].y = badGuys[bad].y + 9;
            if(useSound)
            {
              play_sample((SAMPLE *)item[7],vol,pan, freq, FALSE);
            }
            i = MAX_SHOTS;
            badGuys[bad].other[0] = 20;  /* wait 20 frames to fire again */
          }
          i++;
        } while(i < MAX_SHOTS);
      }
    }
  }
}

/* Sphere fighter #2 */
void SphereFighter2Think(int bad)
{
  register int i = 0;

  badGuys[bad].other[0]--;

  /* restore some weapon power */
  badGuys[bad].weaponPower += 1;

  /* adjust position */
  if((random() % 2) == 1)
  {
    badGuys[bad].x += badGuys[bad].speed;
  }

  /* Try to get infront of player */
  if((badGuys[bad].y+8) < me.y) /* above player */
  {
    if((random() % 2) == 1)
    {
      badGuys[bad].y += badGuys[bad].speed;
    }
  } else if((badGuys[bad].y+11) > (me.y+ship[me.action].y))/* below player */
  {
    if((random() % 2) == 1)
    {
      badGuys[bad].y -= badGuys[bad].speed;
    }
  } else /* infront of player */
  {
    /* Lets fire a shot */
    if(badGuys[bad].other[0] <= 0 && me.health >= 0)
    {
      if(badGuys[bad].weaponPower >= 10)
      {
        badGuys[bad].weaponPower -= 10;
        i = 0;
        do {
          if(enemyShots[i].type == -1)
          {
            enemyShots[i].type = badGuys[bad].curLaser;
            enemyShots[i].x = badGuys[bad].x + enemies[0].x - 10;
            enemyShots[i].y = badGuys[bad].y + 6;
            if(useSound)
            {
              play_sample((SAMPLE *)item[7],vol,pan, freq, FALSE);
            }
            i = MAX_SHOTS;
            badGuys[bad].other[0] = 15;
          }
          i++;
        } while(i < MAX_SHOTS);
      }
      if(badGuys[bad].weaponPower >= 10)
      {
        badGuys[bad].weaponPower -= 10;
        i = 0;
        do {
          if(enemyShots[i].type == -1)
          {
            enemyShots[i].type = badGuys[bad].curLaser;
            enemyShots[i].x = badGuys[bad].x + enemies[1].x - 10;
            enemyShots[i].y = badGuys[bad].y + 17;
            if(useSound)
            {
              play_sample((SAMPLE *)item[7],vol,pan, freq, FALSE);
            }
            i = MAX_SHOTS;
          }
          i++;
        } while(i < MAX_SHOTS);
      }
    }
  }
}

