#ifndef _GRAPH_H
#define _GRAPH_H

#include "fixed.h"

typedef struct
{
  int xmin, xmax;
  int ymin, ymax;
} VIEW;

#define pixels2bytes(n)  ((n+7)/8)

typedef struct tagPCXHEAD {
  char manufacturer;
  char version;
  char encoding;
  char bits_per_pixel;
  short xmin, ymin;
  short xmax, ymax;
  short hres;
  short vres;
  char palette[48];
  char reserved;
  char color_planes;
  short bytes_per_line;
  short palette_type;
  char filler[58];
} PCXHEAD;

/* Global variables located in GRAPH.C */
extern unsigned char *vidBuffer;
extern unsigned int yLookup[200];
extern unsigned char palette[768];
extern VIEW theView;

/* functions located in GRAPH.C */
extern int InitGraphics(void);
extern void TermGraphics(void);
extern void PlotPixel(unsigned char *buffer, int x, int y,
                      unsigned char color);
extern unsigned char GetPixel(unsigned char *buffer, int x, int y);
extern void ClearVidBuffer(unsigned char *buffer);
extern void DisplayVidBuffer(unsigned char *buffer);
extern void BitBlit(unsigned char *source, unsigned char *dest, int xSize,
             int ySize, int xLoc, int yLoc);
extern void BitBlit2(unsigned char *source, unsigned char *dest, int xSize,
             int ySize, int xLoc, int yLoc);
extern void TransBitBlit(unsigned char *source, unsigned char *dest,
      int xSize, int ySize, int xLoc, int yLoc, unsigned char trans);
extern void BufferCopy(unsigned char *source, unsigned char *dest);
extern void SetPalette(void);
extern int FindNearestColor(unsigned char r, unsigned char g,
                            unsigned char b);
extern void DrawLine(short x1, short y1, short x2, short y2,
                     unsigned char color);
extern void DrawLine2(short x1, short y1, short x2, short y2,
                      unsigned char color);
extern void DrawScaledBitmap(int xsize, int ysize, int newx, int newy,
                             int xpos, int ypos, unsigned char *image);
extern void TransDrawScaleBitmap(int xsize, int ysize, int newx, int newy,
                                 int xpos, int ypos, unsigned char *image,
                                 unsigned char trans);
extern int IsGreaterThan(int list[], int numItems, int val);
extern void Melt(unsigned char *newImage);
extern void SavePCXFile(char *fname);


#endif

