#include <stdio.h>
#include <dpmi.h>

#include "mouse.h"


int CheckMouseDriver(void)
{
  __dpmi_regs regs;
  
  regs.x.ax = 0x0000;
  __dpmi_int(0x33, &regs);
  if (regs.x.ax == 0xffff)
  {
    return 1;
  } else
  {
    return 0;
  }
}


void ShowMousePointer(void)
{
  __dpmi_regs regs;

  regs.x.ax = 0x0001;
  __dpmi_int(0x33, &regs);
}


void HideMousePointer(void)
{
  __dpmi_regs regs;

  regs.x.ax = 0x0002;
  __dpmi_int(0x33, &regs);
}


void GetMouseCoords(int *x, int *y, int *buttons)
{
  __dpmi_regs regs;

  regs.x.ax = 0x0003;
  __dpmi_int(0x33, &regs);
  if (x != NULL)
  {
    *x = regs.x.cx;
  }
  if (y != NULL)
  {
    *y = regs.x.dx;
  }
  if (buttons != NULL)
  {
    *buttons = regs.x.bx;
  }
}


void SetMouseCoords(int x, int y)
{
  __dpmi_regs regs;

  regs.x.ax = 0x0004;
  regs.x.cx = (unsigned) x;
  regs.x.dx = (unsigned) y;
  __dpmi_int(0x33, &regs);
}
