#ifndef _SPACE_H
#define _SPACE_H

/* number of stuff */
#define NUM_SHIPS         3
#define NUM_ROCKS         2
#define NUM_STARS        60
#define NUM_METEORS       7
#define NUM_BACKGROUND    1
#define MAX_SHOTS        20
#define MAX_EXPLOSIONS   50
#define NUM_POWER_UPS     6
#define NUM_EXP_FRAMES    5
#define NUM_LASERS        4
#define NUM_ENLASERS      4
#define NUM_MISSLES       2
#define MAX_POWER_UPS     6
#define NUM_BUYPICS       5
#define MAX_BADGUYS       300
#define NUM_BADONSCREEN   5
#define MAX_WEAPON_ICONS  5
#define NUM_BIGBACK       7
#define NUM_ENEMIES       6   /*  0    => sphere fighter #1
                                  1    => sphere fighter #2
                                  2-3  => Boss #1
                                  4-5  => Boss #2
                              */

/* actions */
#define MOVE          0

/* number of frames per action */
#define MOVE_FRAMES   3


typedef struct
{
  int x, y, z;
  int remake;
} STAR;

typedef struct
{
  int x, y;
  unsigned char *bits;
} MBITMAP;

typedef struct
{
  int x, y;
  int frame;
  int delay;
  int wait;
  int type;
} EXPLOSION;

typedef struct
{
  int x, y;
  int action;
  int frame;
  int speed;
  int weapons;      /* bitfield of weapons */
  int numMissles;
  int maxWeaponPower;
  int weaponPower;
  int maxDrivePower;
  int drivePower;
  int disTravel;
  int health;
  long score;
  int curLaser;
  int other[10];  /* for miscellaneous counters */
} PLAYER;

typedef struct
{
  int x, y;
  int type;
} SHOT;

typedef struct
{
  int xmin, ymin;
  int xmax, ymax;
} COORDS;

typedef struct
{
  int type;
  int y;
} BADGUYLIST;

/* Global variables */
extern STAR stars[NUM_STARS];
extern STAR meteors[NUM_METEORS];
extern STAR powerUpInfo[MAX_POWER_UPS];
extern EXPLOSION explosions[MAX_EXPLOSIONS];
extern PLAYER me;
extern PLAYER badGuys[NUM_BADONSCREEN];
extern BADGUYLIST badGuyList[MAX_BADGUYS];
extern MBITMAP ship[NUM_SHIPS];
extern MBITMAP rocks[NUM_ROCKS];
extern MBITMAP background[NUM_BACKGROUND];
extern MBITMAP lasers[NUM_LASERS];
extern MBITMAP enLasers[NUM_ENLASERS];
extern MBITMAP exp[NUM_EXP_FRAMES];
extern MBITMAP enemies[NUM_ENEMIES];
extern MBITMAP numbers[10];
extern MBITMAP health1;
extern MBITMAP missle[NUM_MISSLES];
extern MBITMAP weaponIcon[MAX_WEAPON_ICONS];
extern MBITMAP bigBack[NUM_BIGBACK];
extern MBITMAP powerUps[NUM_POWER_UPS];
extern MBITMAP buyPics[NUM_BUYPICS];
extern MBITMAP selector;
extern SHOT shots[MAX_SHOTS];
extern SHOT enemyShots[MAX_SHOTS];
extern void *item[9];
extern char soundFiles[9][81];
extern int useSound;
extern int digicard;
extern int midicard;
extern int vol;
extern int freq;
extern int pan;
extern int useStars, scaleBack, solidBack;
extern int whichBigBack;
extern int levelDistance;
extern int mustKillBoss;
extern int bossOnScreen;
extern int canWarp;
extern int useMeteors;
extern int pointCount;
extern int useBackGroundImage;
extern int addBadGuyDistance;
extern int useMouse;
extern int godMode;


#endif

